Subject: Re: consistent_free re-revisited

From: Tom Rini <[email-masked]>
Date: Thu, 12 Sep 2002 07:51:46 -0700

On Thu, Sep 12, 2002 at 09:23:15AM +0200, Benjamin Herrenschmidt wrote:
> >> That's the least of our worries - the current consistent_alloc() is
> >> badly broken.  It breaks the DMA-mapping.txt rules, because it can't
> >> safely be called from interrupt context.  I think we need generic
> >> changes (gfp masks to various functions) to fix this sanely.
> >
> >IIRC, to fix the interrupt context bit, we need something like the
> >following, which was Paul's idea, and he said he would talk to Dave M.
> >about it.  Did anything ever happen there?
>
> I tend to hate anything that relies on in_interrupt() as they
> are other contexts that will have in_interrupt() cleared but still
> have the same limitations. Typically, anything on the VM path must
> do either GFP_ATOMIC or GFP_NOIO allocations, wether it's running
> at interrupt time or not.

The problem is that the atomic pool is limited, iirc.

--
Tom Rini (TR1265)
http://gate.crashing.org/~trini/

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/